#include "kmeansto.h"
#include "threadmgr.h"

KMeansTO::KMeansTO(ThreadMgr* thread_mgr, int num_records, int k, int num_samples, Scalar* records, int num_attempts, bool is_only_cluster)
    : _numRecords(num_records), _k(k), _numSamples(num_samples),
      _numAttempts(num_attempts), _threadMgr(thread_mgr)
{
    if (is_only_cluster)
        _records = records;
    else
    {
        _records = (Scalar*)malloc(num_records * num_samples * sizeof(Scalar));
        memcpy(_records, records, num_records * num_samples * sizeof(Scalar));
    }
}
/*KMeansTO::KMeansTO(int num_records, int k, int num_samples, Scalar* records, int num_attempts)
    : _numRecords(num_records), _k(k), _numSamples(num_samples), _records(records),
      _numAttempts(num_attempts)//, _threadMgr(thread_mgr)
{
//        connect(this, SIGNAL(Finished(int,const int*,const Scalar*)),
//                tmgr, SLOT(KMeansFinished(int,const int*,const Scalar*)), Qt::QueuedConnection);
}*/

void KMeansTO::Start()
{
//    cerr << "Clustering " << _k << " starting" << endl;
    Scalar* centers = (Scalar*)malloc(_k*_numSamples*sizeof(Scalar));
    int* assignments = (int*)malloc(_numRecords*sizeof(int));
    RunKMeansPlusPlus(_numRecords, _k, _numSamples, _records, _numAttempts, centers, assignments);
    free(_records);
    cerr << "Clustering " << _k << " finished" << endl;
//    emit Finished(_k, assignments, centers);
    _threadMgr->KMeansFinished(_k, assignments, centers);
//    cerr << "Signal emitted, " << _k << endl;
}
