#-------------------------------------------------
#
# Project created by QtCreator 2012-01-09T11:39:18
#
#-------------------------------------------------

QT       += core gui network

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

!win32 {
    QMAKE_CXXFLAGS += -std=c++11
}
macx {
QMAKE_CXXFLAGS += -stdlib=libc++
QMAKE_CXXFLAGS += -Wno-dangling-else

QMAKE_CFLAGS_PPC_64     -= -arch ppc64 -Xarch_ppc64 -mmacosx-version-min=10.5
QMAKE_OBJECTIVE_CFLAGS_PPC_64  -= -arch ppc64 -Xarch_ppc64 -mmacosx-version-min=10.5
QMAKE_CFLAGS_X86_64     -= -arch x86_64 -Xarch_x86_64 -mmacosx-version-min=10.5
QMAKE_OBJECTIVE_CFLAGS_X86_64  -= -arch x86_64 -Xarch_x86_64 -mmacosx-version-min=10.5
QMAKE_CXXFLAGS_PPC_64   -= -arch ppc64 -Xarch_ppc64 -mmacosx-version-min=10.5
QMAKE_CXXFLAGS_X86_64   -= -arch x86_64 -Xarch_x86_64 -mmacosx-version-min=10.5
QMAKE_LFLAGS_PPC_64     -= -arch ppc64 -Xarch_ppc64 -mmacosx-version-min=10.5
QMAKE_LFLAGS_X86_64     -= -arch x86_64 -Xarch_x86_64 -mmacosx-version-min=10.5

QMAKE_LFLAGS +=  -lc++abi
QMAKE_LFLAGS += /opt/local/lib/gcc47/libgfortran.a
QMAKE_LFLAGS += /opt/local/lib/gcc47/libquadmath.a
QMAKE_LFLAGS += /opt/local/lib/gcc47/gcc/x86_64-apple-darwin11/4.7.3/libgcc.a
LIBS += shared/c++/libc++.dylib  #This one works with clang
}

TARGET = WaveSorter
TEMPLATE = app

#The following flags govern different builds, comment/uncomment accordingly
#--------
#CONFIG += extra
CONFIG(extra) {
QMAKE_CXXFLAGS += -DHAVE_EXTRA
}

CONFIG += use_gsl

#QMAKE_CXXFLAGS += -DHAS_CUDA
#--------

CONFIG(use_gsl) {
QMAKE_CXXFLAGS += -DUSE_GSL
}

win32 {
QMAKE_LFLAGS += /STACK:10000000 /machine:x64 /release
}

CONFIG(debug, debug|release) {
    OBJECTS_DIR = qt_source/object_files-debug
} else {
    OBJECTS_DIR = qt_source/object_files-release
}
MOC_DIR = qt_source/moc_files
UI_DIR = qt_source/ui_files

SOURCES += main.cpp \
    file/input/inputfilebase.cpp \
    file/output/outputfilebase.cpp \
    file/filebase.cpp \
    gui/mainwindow.cpp \
    gui/mdi/wavegui.cpp \
    gui/mdi/paramgui.cpp \
    gui/widgets/wave/wavewidget.cpp \
    gui/mdi/electrodegui.cpp \
    gui/mdi/loggui.cpp \
    gui/wavespacegui.cpp \
    gui/widgets/histwidget.cpp \
    memrep/parameters/paramsbase.cpp \
    memrep/wavedata.cpp \
    memrep/classification.cpp \
    globals/log.cpp \
    analysis/transforms/haarto.cpp \
    analysis/analysistobase.cpp \
    analysis/transforms/pca_to.cpp \
    gui/widgets/progressbar.cpp \
    gui/mdi/progressgui.cpp \
    analysis/cluster/kmeansto.cpp \
    gui/widgets/wave/scanwavewidget.cpp \
    analysis/cluster/klustakwikto.cpp \
    analysis/cluster/clusmethodtobase.cpp \
    analysis/transforms/transformtobase.cpp \
    globals/globals.cpp \
    memrep/wavetemplate.cpp \
    file/output/wfmfileout.cpp \
    file/input/waves/mexfile.cpp \
    file/input/waves/fetfile.cpp \
    analysis/cluster/manualto.cpp \
    memrep/parameters/cluster/manualpars.cpp \
    memrep/parameters/cluster/clusterparamsbase.cpp \
    memrep/parameters/cluster/kkparameters.cpp \
    memrep/drawing/polyline.cpp \
    file/output/simplebinary.cpp \
    file/output/rexefile.cpp \
    gui/widgets/aboutgui.cpp \
    file/output/parfileout.cpp \
    memrep/parameters/cluster/kmeanspars.cpp \
    file/input/wfmfilein.cpp \
    gui/profilegui.cpp \
    gui/widgets/labelwidget.cpp \
    memrep/specs/wavespaceguispec.cpp \
    memrep/parameters/cluster/spcparameters.cpp \
    analysis/cluster/spc_to.cpp \
    file/input/spcfilein.cpp \
    memrep/drawing/drawlinebase.cpp \
    memrep/drawing/circle.cpp \
    file/output/simpleascii.cpp \
    file/input/kmeansfilein.cpp \
    file/input/waves/asciifilein.cpp \
    file/output/userclufileout.cpp \
    file/input/profilein.cpp \
    memrep/parameters/profile.cpp \
    file/output/profileout.cpp \
    memrep/parameters/sessionpars.cpp \
    gui/batchgui.cpp \
    analysis/threads/mgr/covthreadmgr.cpp \
    analysis/threads/worker/covarianceto.cpp \
    file/input/userclufilein.cpp \
    gui/widgets/wave/cluswavewidget.cpp \
    analysis/cluster/autoclassto.cpp \
    memrep/parameters/cluster/autoclasspars.cpp \
    file/output/db2fileout.cpp \
    file/output/hd2fileout.cpp \
    file/output/modelfileout.cpp \
    file/output/acparamsout.cpp \
    file/input/casedatafilein.cpp \
    file/output/mclufileout.cpp \
    file/input/mclufilein.cpp \
    analysis/threads/mgr/histwgtthreadmgr.cpp \
    analysis/threads/worker/histwgtto.cpp \
    file/input/waves/apmfile.cpp \
    file/input/waves/plxfile.cpp \
    analysis/threads/mgr/histthreadmgr.cpp \
    analysis/threads/worker/histto.cpp \
    file/output/userdatafileout.cpp \
    analysis/threads/mgr/threadmgr.cpp \
    analysis/threads/worker/workerto.cpp \
    analysis/threads/worker/histwgtscatterto.cpp \
    analysis/threads/mgr/histscattermgr.cpp \
    analysis/threads/mgr/histwgtscattermgr.cpp \
    analysis/threads/worker/histscatterto.cpp \
    globals/wexception.cpp \
    memrep/specs/clusterspec.cpp \
    analysis/batch.cpp \
    globals/wv.cpp \
    globals/utils.cpp \
    memrep/clustermediator.cpp \
    analysis/threads/mgr/clustermgr.cpp \
    analysis/threads/worker/clusterto.cpp \
    memrep/specs/resultspec.cpp \
    memrep/specs/usertransformspec.cpp \
    memrep/specs/scalespec.cpp \
    analysis/dunn.cpp \
    memrep/drawing/biellipse.cpp \
    analysis/threads/mgr/haarmgr.cpp \
    analysis/threads/worker/haarworkerto.cpp \
    file/input/waves/waveformsinbase.cpp \
    file/input/waves/nevfile.cpp \
    analysis/threads/worker/containsto.cpp \
    analysis/threads/mgr/containsmgr.cpp \
    analysis/threads/mgr/alignmentmgr.cpp \
    analysis/threads/worker/alignmentto.cpp \
    analysis/threads/mgr/diffmgr.cpp \
    analysis/threads/worker/diffto.cpp \
    file/output/usertclufileout.cpp \
    analysis/channelbatch.cpp \
    file/wfmfileappend.cpp \
    gui/gui.cpp \
    license/licensemgr.cpp \
    license/crypt.cpp

CONFIG(use_gsl) {
SOURCES +=  \
    analysis/gsl_utils/mgsl.cpp \
    analysis/threads/mgr/radix2mgr.cpp \
    analysis/threads/worker/radix2to.cpp \
    analysis/transforms/splineto.cpp \
    analysis/threads/worker/splineworkerto.cpp \
    analysis/threads/mgr/splinemgr.cpp \
    analysis/transforms/fourierto.cpp \
    analysis/threads/worker/fourierworkerto.cpp \
    analysis/threads/mgr/fouriermgr.cpp
}

CONFIG(extra) {
SOURCES +=  \
    gui/wavegridgui.cpp \
    gui/widgets/wave/gridwavewidget.cpp \
    gui/widgets/wave/hovercatcher.cpp
}

HEADERS  += gui/mainwindow.h \
    globals/qt_headers.h \
    globals/globals.h \
    file/filebase.h \
    file/input/inputfilebase.h \
    file/output/outputfilebase.h \
    gui/wavespacegui.h \
    gui/widgets/wave/wavewidget.h \
    gui/widgets/histwidget.h \
    gui/mdi/wavegui.h \
    gui/mdi/paramgui.h \
    gui/mdi/electrodegui.h \
    gui/mdi/loggui.h \
    memrep/wavedata.h \
    memrep/classification.h  \
    memrep/parameters/paramsbase.h \
    globals/log.h \
    analysis/transforms/haarto.h \
    analysis/analysistobase.h \
    analysis/transforms/pca_to.h \
    gui/widgets/progressbar.h \
    gui/mdi/progressgui.h \
    analysis/cluster/kmeansto.h \
    gui/widgets/wave/scanwavewidget.h \
    analysis/cluster/klustakwikto.h \
    analysis/cluster/clusmethodtobase.h \
    analysis/transforms/transformtobase.h \
    memrep/wavetemplate.h \
    file/output/wfmfileout.h \
    file/input/waves/mexfile.h \
    file/input/waves/fetfile.h \
    analysis/cluster/manualto.h \
    memrep/parameters/cluster/manualpars.h \
    memrep/parameters/cluster/clusterparamsbase.h \
    memrep/parameters/cluster/kkparameters.h \
    memrep/drawing/polyline.h \
    file/output/simplebinary.h \
    file/output/rexefile.h \
    gui/widgets/aboutgui.h \
    file/output/parfileout.h \
    memrep/parameters/cluster/kmeanspars.h \
    file/input/wfmfilein.h \
    gui/profilegui.h \
    gui/widgets/labelwidget.h \
    memrep/specs/wavespaceguispec.h \
    memrep/parameters/cluster/spcparameters.h \
    analysis/cluster/spc_to.h \
    file/input/spcfilein.h \
    memrep/drawing/drawlinebase.h \
    memrep/drawing/circle.h \
    file/output/simpleascii.h \
    file/input/kmeansfilein.h \
    file/input/waves/asciifilein.h \
    file/output/userclufileout.h \
    file/input/profilein.h \
    memrep/parameters/profile.h \
    file/output/profileout.h \
    memrep/parameters/sessionpars.h \
    gui/batchgui.h \
    analysis/threads/mgr/covthreadmgr.h \
    analysis/threads/worker/covarianceto.h \
    file/input/userclufilein.h \
    gui/widgets/wave/cluswavewidget.h \
    analysis/cluster/autoclassto.h \
    memrep/parameters/cluster/autoclasspars.h \
    file/output/db2fileout.h \
    file/output/hd2fileout.h \
    file/output/modelfileout.h \
    file/output/acparamsout.h \
    file/input/casedatafilein.h \
    file/output/mclufileout.h \
    file/input/mclufilein.h \
    analysis/threads/mgr/histwgtthreadmgr.h \
    analysis/threads/worker/histwgtto.h \
    file/input/waves/apmfile.h \
    file/input/waves/plxfile.h \
    analysis/threads/mgr/histthreadmgr.h \
    analysis/threads/worker/histto.h \
    file/output/userdatafileout.h \
    analysis/threads/mgr/threadmgr.h \
    analysis/threads/worker/workerto.h \
    globals/stl_headers.h \
    analysis/threads/worker/histwgtscatterto.h \
    analysis/threads/mgr/histscattermgr.h \
    analysis/threads/mgr/histwgtscattermgr.h \
    analysis/threads/worker/histscatterto.h \
    globals/wexception.h \
    memrep/specs/clusterspec.h \
    analysis/batch.h \
    globals/wv.h \
    globals/utils.h \
    globals/ut_def.h \
    memrep/clustermediator.h \
    analysis/threads/mgr/clustermgr.h \
    analysis/threads/worker/clusterto.h \
    memrep/specs/resultspec.h \
    memrep/specs/usertransformspec.h \
    globals/boost_headers.h \
    memrep/specs/scalespec.h \
    analysis/dunn.h \
    memrep/drawing/biellipse.h \
    memrep/specs/histspec.h \
    analysis/threads/mgr/haarmgr.h \
    analysis/threads/worker/haarworkerto.h \
    file/input/waves/waveformsinbase.h \
    file/input/waves/nevfile.h \
    memrep/drawing/centerspec.h \
    analysis/threads/worker/containsto.h \
    analysis/threads/mgr/containsmgr.h \
    analysis/threads/mgr/alignmentmgr.h \
    analysis/threads/worker/alignmentto.h \
    analysis/threads/mgr/diffmgr.h \
    analysis/threads/worker/diffto.h \
    file/output/usertclufileout.h \
    analysis/channelbatch.h \
    file/wfmfileappend.h \
    gui/gui.h \
    globals/math/msl_histogram.h \
    globals/math/msl_histogram_def.h \
    globals/math/msl_globals.h \
    globals/math/msl_statistics.h \
    globals/math/msl_statistics_def.h \
    globals/math/msl_blas.h \
    globals/math/msl_blas_def.h \
    globals/math/lapack/msl_eigen.h \
    globals/math/lapack/msl_eigen_def.h \
    globals/math/msl_pca.h \
    globals/math/msl_utils.h \
    globals/math/lapack/msl_linalg.h \
    globals/math//lapack/msl_linalg_def.h \
    globals/math/msl_matrix.h \
    globals/math/wavelet/msl_wavelet.h \
    globals/math/wavelet/leasy_wavelet.h \
    globals/math/wavelet/msl_wavelet_def.h \
    globals/math/wavelet/leasy_wavelet_def.h \
    globals/math/msl_interp.h \
    globals/msl_headers.h \
    globals/math/msl_matrix_def.h \
    globals/math/msl_pca_def.h \
    globals/math/msl_utils_def.h \
    globals/math/msl_interp_def.h \
    license/licensemgr.h \
    license/crypt.h \
    globals/math/msl_vector.h \
    globals/math/msl_block.h \
    globals/math/msl_block_def.h \
    globals/math/msl_vector_def.h

CONFIG(use_gsl) {
HEADERS += \
    globals/gsl_headers.h \
    analysis/gsl_utils/mgsl.h \
    analysis/threads/mgr/radix2mgr.h \
    analysis/threads/worker/radix2to.h \
    analysis/transforms/splineto.h \
    analysis/threads/worker/splineworkerto.h \
    analysis/threads/mgr/splinemgr.h \
    analysis/transforms/fourierto.h \
    analysis/threads/worker/fourierworkerto.h \
    analysis/threads/mgr/fouriermgr.h
}

CONFIG(extra) {
HEADERS +=     gui/wavegridgui.h \
    gui/widgets/wave/gridwavewidget.h \
    gui/widgets/wave/hovercatcher.h
}

FORMS    += forms/mainwindow.ui \
    forms/mdi/wavegui.ui \
    forms/mdi/paramgui.ui \
    forms/mdi/electrodegui.ui \
    forms/mdi/loggui.ui \
    forms/wavespacegui.ui \
    forms/widgets/progressbar.ui \
    forms/mdi/progressgui.ui \
    forms/widgets/aboutgui.ui \
    forms/profilegui.ui \
    forms/batchgui.ui \
    forms/wavegridgui.ui

macx {
    INCLUDEPATH += shared
    INCLUDEPATH += shared/boost
    CONFIG(use_gsl) {
        INCLUDEPATH += /usr/local/include
        LIBS += /usr/local/lib/libgsl.a /usr/local/lib/libgslcblas.a
        QMAKE_LFLAGS_RPATH += shared/gsl
        QMAKE_LFLAGS_RPATH += ../../../shared/gsl
    } else {
        INCLUDEPATH += /usr/local/openblas-0.2.6/include
        LIBS += shared/openblas/libopenblas.a
        QMAKE_LFLAGS_RPATH += shared/openblas
    }

    QMAKE_LFLAGS_RPATH += shared/qt

    QMAKE_LFLAGS_RPATH += shared/c++
    LIBS += shared/c++/libc++.dylib
}
win32 {
    INCLUDEPATH += C:/gsl-1.15
    CONFIG(debug, debug|release) {
#        LIBS += -LC:/gsl-1.15/build.vc10/dll/Win32/Debug -lgsl \ #/gsl.lib \
#                 -LC:/gsl-1.15/build.vc10/dll/Win32/Debug -lcblas #/cblas.lib
       LIBS += -LC:/gsl-1.15-x64/build.vc10/lib/x64/Release -lgsl -lcblas
    } else {
       LIBS += -LC:/gsl-1.15-x64/build.vc10/lib/x64/Release -lgsl -lcblas
#        LIBS += -LC:/gsl-1.15/build.vc10/lib/Win32/Release -lgsl -lcblas
    }
        #lib for static, dll/Debug for shared libraries
    INCLUDEPATH += ../shared \
                ../shared/boost \
                ../../cumath
#    LIBS += -L../../../cumath/release -lcumath
}
unix:|macx {
    INCLUDEPATH += /home/matt/openblas/openblas-0.2.6-nothread/lapack-3.4.2/lapacke/include
    INCLUDEPATH += shared #\
#                    /usr/local/include
    INCLUDEPATH += shared/boost
#    LIBS += -L/usr/local/lib -lgsl -lgslcblas
#    LIBS += /home/matt/openblas/openblas-0.2.6-nothread/libopenblas.a -lgfortran
}
