#ifndef CHANNELBATCH_H
#define CHANNELBATCH_H

#include "../globals/globals.h"
#include "../memrep/clustermediator.h"
#include "../file/input/waves/waveformsinbase.h"

class MainWindow;
class ChannelBatch : public QObject
{
    Q_OBJECT

    public:
        ChannelBatch(WavesFilePtr waves_file, MainWindow* mw);
        ~ChannelBatch();

        void Run();

    signals:
        void PreprocFinished(WavesFilePtr waves_file, short elc);

    private:
#ifndef Q_OS_WIN
        ChannelBatch(const ChannelBatch&) = delete;
        ChannelBatch& operator=(const ChannelBatch&) = delete;
#else
        ChannelBatch(const ChannelBatch&);
        ChannelBatch& operator=(const ChannelBatch&);
#endif
        void Process();

        ClusterMediator& _cmed;
        MainWindow* _mainWindow;
        std::thread* _thread;
        WavesFilePtr _wavesFile;
};

#endif // CHANNELBATCH_H
