#ifndef AUTOCLASSTO_H
#define AUTOCLASSTO_H

#include "clusmethodtobase.h"
#include "../../memrep/parameters/cluster/autoclasspars.h"
#include "../../file/output/db2fileout.h"
#include "../../file/output/hd2fileout.h"
#include "../../file/output/modelfileout.h"
#include "../../file/output/acparamsout.h"
#include "../../file/input/casedatafilein.h"
#include "../../file/output/mclufileout.h"

class AutoClassTO : public ClusMethodTOBase
{
    Q_OBJECT

    public:
        AutoClassTO(wv::CLUSTER_ID cid, wv::TRANSFORM transform, MatCPtr waves,
                    const std::string& wfm_file);
        virtual ~AutoClassTO() override {}
        virtual void Start() override;
        virtual std::string Name() const override { return "autoclass"; }
        virtual wv::CLUSTER_METHOD Method() const override { return wv::AUTOCLASS; }

    protected slots:
        virtual void LoadClassification(int exit_code) override;

    private slots:
        void ReadStandardOutputR();
        void ReadStandardErrorR();
        void StateChangeR(QProcess::ProcessState);
        void ErrorR(QProcess::ProcessError);

    private:
        void MakeDb2();
        void MakeHd2();
        void MakeModel();
        void MakeSParams();
        void MakeRParams();

        std::string _db2File, _hd2File, _modelFile, _sParamsFile, _rParamsFile, _caseDataFile;
        QProcess* _resultsProc;
};

#endif // AUTOCLASSTO_H
