#ifndef MANUALTO_H
#define MANUALTO_H

#include "../../globals/log.h"
#include "clusmethodtobase.h"
#include "../../file/output/mclufileout.h"
#include "../../memrep/parameters/cluster/manualpars.h"
#include "../../memrep/specs/clusterspec.h"
#include "../../analysis/threads/mgr/containsmgr.h"

struct CenterSpec;
class ManualTO : public ClusMethodTOBase
{
    Q_OBJECT

    public:
        ManualTO(wv::CLUSTER_ID cid, WaveData* wave_data,
                     const std::string& wfm_file);
        virtual ~ManualTO() override {}

        virtual void SetWindow(int, int) override;

        virtual std::string Name() const override { return "Manual"; }
        virtual wv::CLUSTER_METHOD Method() const override { return wv::MANUAL; }

    public slots:
        virtual void Start() override;

    private:
        CluSpecPtr _cluSpec;
        const boost::dynamic_bitset<>* _priorAccepted; //The spikes accepted from any previous analysis; the
            //current clustering builds off of this.
        boost::dynamic_bitset<> _toggledWaves;
};

#endif // MANUALTO_H
