#include "alignmentmgr.h"
#include "../worker/alignmentto.h"

AlignmentMgr::AlignmentMgr(AlignmentSpec& alignment_spec)
    : ThreadMgr(QThread::idealThreadCount(), 25000), _alignmentSpec(alignment_spec)
{
    int num_records = _alignmentSpec.raw->size1;
    _recordsPerThread = num_records / NumThreads();
}

WorkerTO* AlignmentMgr::CreateWorkerTO(int thd_num)
{
    int i_start = thd_num*_recordsPerThread;
    _alignmentSpec.i_start = i_start;
    _alignmentSpec.i_end = (thd_num==NumThreads()-1)
            ? _alignmentSpec.raw->size1
            : i_start+_recordsPerThread;
    AlignmentTO* to = new AlignmentTO(thd_num, _alignmentSpec);
    return to;
}

