#include "clustermgr.h"
#include "../../../memrep/clustermediator.h"
#include "../worker/clusterto.h"

ClusterMgr::ClusterMgr(const std::vector<wv::CLUSTER_ID>& cids)
    : ThreadMgr( std::min(3,(int)cids.size()) , 25000), _cids(cids), _numThreadsRemaining(NumThreads())
    //### 3 From parameter

{
}

WorkerTO* ClusterMgr::CreateWorkerTO(int thd_num)
{
    int num_threads = NumThreads(),
            num_cids = _cids.size();
    std::vector<wv::CLUSTER_ID> to_cids; //The cids for a particular thread object
    for (int i=0; i<num_cids; ++i)
        if (i%num_threads==thd_num) to_cids.push_back( _cids[i] );
    ClusterTO* to = new ClusterTO(thd_num, to_cids);
    return to;
}

void ClusterMgr::OnThreadFinished(void*)
{
    --_numThreadsRemaining;
}

bool ClusterMgr::HasCID(wv::CLUSTER_ID cid) const
{
    return !_cids.empty()
            && std::find(_cids.begin(), _cids.end(), cid)!=_cids.end();
}
