#include "diffmgr.h"
#include "../worker/diffto.h"

DiffMgr::DiffMgr(DiffSpec& diff_spec)
    : ThreadMgr(QThread::idealThreadCount(), 25000), _diffSpec(diff_spec)
{
    int num_records = _diffSpec.raw->size1;
    _recordsPerThread = num_records / NumThreads();
}

WorkerTO* DiffMgr::CreateWorkerTO(int thd_num)
{
    int i_start = thd_num*_recordsPerThread;
    _diffSpec.i_start = i_start;
    _diffSpec.i_end = (thd_num==NumThreads()-1)
            ? _diffSpec.raw->size1
            : i_start+_recordsPerThread;
    DiffTO* to = new DiffTO(thd_num, _diffSpec);
    return to;
}

