#ifndef FOURIERMGR_H
#define FOURIERMGR_H

#include "threadmgr.h"

class FourierMgr : public ThreadMgr
{
    public:
        struct FourierSpec
        {
            FourierSpec(const wv_matrix* waves_);
            size_t i_start, i_end;
            wv_matrix* transform;
            const wv_matrix* waves;
        };

        explicit FourierMgr(FourierSpec& fourier_spec); //Non const because it also contains writeable members.  Could
            //break this in two, but don't want to bother...

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        FourierSpec _fourierSpec;
        int _recordsPerThread;
};

#endif // FOURIERMGR_H
