#ifndef HISTSCATTERMGR_H
#define HISTSCATTERMGR_H

#include "../../../globals/globals.h"
#include "../../../gui/widgets/histwidget.h"
#include "../../../memrep/specs/wavespaceguispec.h"
#include "../../../memrep/specs/histspec.h"
#include "../mgr/threadmgr.h"

class WorkerTO;
class HistScatterMgr : public ThreadMgr
{
    public:
        explicit HistScatterMgr(HistWidget* hist_widget, HistSpec hist_spec);

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;
        wv_matrix_int* MatAccept() { return _matAccept; }
        wv_matrix_int* MatUnaccept() { return _matUnaccept; }

    protected:
        virtual void OnThreadFinished(void* result) override;

    private:
        HistWidget* _histWidget;
        HistSpec _histSpec;
        wv_matrix_int* _matAccept, * _matUnaccept;
        int _numRecords, _recordsPerThread;
};

#endif // HISTSCATTERMGR_H
