#include "radix2mgr.h"
#include "../worker/radix2to.h"

Radix2Mgr::Radix2Mgr(Radix2Spec& radix2_spec, wv_matrix* radix2_mat)
    : ThreadMgr(QThread::idealThreadCount(), 25000),
      _radix2Spec(radix2_spec), _radix2Mat(radix2_mat)
{
    int num_records = _radix2Spec.mat->size1;
    _recordsPerThread = num_records / NumThreads();
}

WorkerTO* Radix2Mgr::CreateWorkerTO(int thd_num)
{
    int i_start = thd_num*_recordsPerThread;
    _radix2Spec.i_start = i_start;
    _radix2Spec.i_end = (thd_num==NumThreads()-1)
            ? _radix2Mat->size1
            : i_start+_recordsPerThread;
    Radix2TO* to = new Radix2TO(thd_num, _radix2Spec, _radix2Mat);
    return to;
}

