#ifndef RADIX2MGR_H
#define RADIX2MGR_H

#include "threadmgr.h"

//This is for doing the interpolation in mgsl::AllocateRadix2, which is relatively costly
class Radix2Mgr : public ThreadMgr
{
    public:
        struct Radix2Spec
        {
            Radix2Spec(MatCPtr mat_) :
                i_start(-1), i_end(-1), mat(mat_), x_interp(nullptr)
            {}
            size_t i_start, i_end;
            MatCPtr mat;
            int num_cols;
            const wv::float_t* x_interp;
        };

        explicit Radix2Mgr(Radix2Spec& radix2_spec, wv_matrix* radix2_mat);
            //radix2_mat must already be allocated

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        Radix2Spec _radix2Spec;
        int _recordsPerThread;
        wv_matrix* _radix2Mat; //The new Radix2 matrix
};

#endif // RADIX2MGR_H
