#include "alignmentto.h"

AlignmentTO::AlignmentTO(int thd_num, AlignmentMgr::AlignmentSpec& alignment_spec)
    : WorkerTO(thd_num), _alignmentSpec(alignment_spec)
{
}

void AlignmentTO::Start()
{
    wv_matrix* raw = _alignmentSpec.raw;
    const wv_vector_int* offsets = _alignmentSpec.offsets;
    int num_samples = raw->size2;

    wv_vector* temp_row = wv_vector_alloc(num_samples);
    size_t i_end = _alignmentSpec.i_end;
    for (size_t i=_alignmentSpec.i_start; i<i_end; ++i)
    {
        int offset = wv_vector_int_get(offsets, i);
        if (offset==0) continue;
        for (int j=0; j<num_samples; ++j)
        {
            int offset_idx = (j + offset) % num_samples;
            if (offset_idx < 0) offset_idx += num_samples; //REquired b/c of definition of % in C
            wv::float_t offset_sample = wv_matrix_get(raw, i, offset_idx);
            wv_vector_set(temp_row, j, offset_sample);
        }
        wv_matrix_set_row(raw, i, temp_row);
    }

    wv_vector_free(temp_row);

    WorkFinished();
}
