#include "covarianceto.h"

CovarianceTO::CovarianceTO(int thd_num, std::list<CovSpec> cov_specs, size_t num_rows, wv_matrix* cov_mat)
    : WorkerTO(thd_num), _covSpecs(cov_specs), _numRows(num_rows), _covMat(cov_mat)
{
}

void CovarianceTO::Start()
{
    auto cov_specs_end = _covSpecs.end();
    for (auto it=_covSpecs.begin(); it!=cov_specs_end; ++it)
    {
        CovSpec cov_spec = *it;

        wv::float_t covariance = wv_stats_covariance_m(cov_spec.data1,
                                                 cov_spec.stride1,
                                                 cov_spec.data2,
                                                 cov_spec.stride2,
                                                 _numRows,
                                                 cov_spec.mean1,
                                                 cov_spec.mean2);

        wv_matrix_set(_covMat, cov_spec.j1, cov_spec.j2, covariance);
        wv_matrix_set(_covMat, cov_spec.j2, cov_spec.j1, covariance);
            //The second statement is redundant if j1==j2, but this is probably
            //faster than testing j1==j2 every time.
    }
    WorkFinished();
}

