#ifndef HISTSCATTERTO_H
#define HISTSCATTERTO_H

#include "../../../globals/globals.h"
#include "../../../gui/widgets/histwidget.h"
#include "../../../memrep/specs/wavespaceguispec.h"
#include "../../../memrep/specs/histspec.h"
#include "../worker/workerto.h"

class HistScatterTO : public WorkerTO
{
    Q_OBJECT
    public:
        explicit HistScatterTO(int thd_num, const HistWidget* hist_widget, HistSpec hist_spec,
                               wv_vector* xdata_vec, wv_vector* ydata_vec);
        ~HistScatterTO();

    public slots:
        void Start();

    private:
        const HistWidget* _histWidget;
        const ScaleSpec* _scaleSpec;
        HistSpec _histSpec;
        wv_vector* _xDataVec, * _yDataVec;
};

#endif // HISTSCATTERTO_H
