#include "histwgtscatterto.h"

HistWgtScatterTO::HistWgtScatterTO(int thd_num, uchar* pixels, const HistWidget* hist_widget, int jstart, int jend) : WorkerTO(thd_num),
    _pixels(pixels), _matAccept(hist_widget->_matAccept), _matUnaccept(hist_widget->_matUnaccept),
    _histWidth(hist_widget->width()), _jStart(jstart), _jEnd(jend)
{
}

void HistWgtScatterTO::Start() //slot
{
    uchar green, white;
    for (int i=0; i<_histWidth; ++i)
        for (int j=_jStart; j<_jEnd; ++j)
        {
            bool is_green = wv_matrix_int_get(_matAccept, i, j),
                    is_white = wv_matrix_int_get(_matUnaccept, i, j);
            if (is_white)
            {
                if (is_green)
                {
                    white = 127;
                    green = 128;
                }
                else
                {
                    white = 255;
                    green = 0;
                }
            }
            else
            {
                white = 0;
                green = (is_green) ? 255 : 0;
            }

            // *** Note: Doing it as below is perfectly possible; add in a maxval and you can get full
            //scaling.  But the fastest method is above.  Make it contingent on _isScatter setting?
            /*
            wv::float_t green_ct = wv_matrix_int_get(_matAccept, i, j),
                    white_ct = wv_matrix_int_get(_matUnaccept, i, j),
                    sum = green_ct + white_ct;
            if (sum==0)
                green = white = 0;
            else
            {
                white = 255.0 * white_ct/(green_ct+white_ct) + 0.5;
                green = 255.0 * green_ct/(green_ct+white_ct) + 0.5;
            }*/

            int idx = (j*_histWidth + i) * 4;
            _pixels[idx+3] = 0xff;
            _pixels[idx+2] = white;
            _pixels[idx+1] = white+green;
            _pixels[idx] = white;
                //Don't understand why but reverse order is required
        }

    WorkFinished();
}
