#ifndef WAVELETTO_H
#define WAVELETTO_H

#include "../../globals/globals.h"
#include "transformtobase.h"
#include "../threads/mgr/haarmgr.h"

#include "../../gui/widgets/progressbar.h"

class HaarTO : public TransformTOBase
{
    Q_OBJECT

    public:
        HaarTO(MatCPtr waves, const std::string& filename, short electrode, ParamsBase* pars, bool is_raw);
        virtual ~HaarTO() override {}

        virtual std::string Name() const override { return (IsRaw())
                    ? wv::TransformName(wv::WAVELET) : wv::TransformName(wv::WAVELET_D); }
        wv::TRANSFORM Transform() const { return (IsRaw()) ? wv::WAVELET : wv::WAVELET_D; }

    protected:
        virtual void Start() override;
};

#endif // WAVELETTO_H
