#ifndef TRANSFORMTOBASE_H
#define TRANSFORMTOBASE_H

#include "../analysistobase.h"

class TransformTOBase : public AnalysisTOBase
{
    public:
        TransformTOBase(MatCPtr waves, const std::string& input_file,
                        short electrode, ParamsBase *pars = NULL, bool is_raw = true);
        virtual ~TransformTOBase() override;
        static TransformTOBase* Create(wv::TRANSFORM transform, MatCPtr waves,
#ifdef USE_GSL
                                        wv::float_t us_per_samp,
#endif
                                       const std::string& input_file, short electrode);

        short Electrode() const { return _electrode; }
        bool IsRaw() const { return _isRaw; }
        MatPtr Waveforms() { return _mat; }

    protected:
        virtual void AnalysisFinished(void* data) override;
        virtual void AnalysisFinished(const void* data) const override;
        void WriteTempFile(MatCPtr transform, wv::TRANSFORM tform = wv::UNKNOWN_TRANSFORM) const;
        virtual std::string InputFileName() const override;

    private:
        short _electrode;
        bool _isRaw; //Whether the data is raw or differentiated.  Eventually replace with an
            //enum type
        MatPtr _mat; //The transformed waveforms
};

#endif // TRANSFORMTOBASE_H
