#include "inputfilebase.h"

InputFileBase::InputFileBase(const std::string& full_path, bool is_binary)
    : FileBase(full_path, QIODevice::ReadOnly, is_binary), _data(NULL)
{
}

void InputFileBase::SetWData(short electrode, WaveData* wave_data)
{
    std::map<short, WaveData*>* map = static_cast< std::map<short, WaveData*>* >(_data);
    if (!map) throw BadData("InputFileBase::SetWData", electrode);
    (*map)[electrode] = wave_data;
}

WaveData* InputFileBase::WData(short electrode) const
{
    std::map<short, WaveData*>* mwdata = static_cast< std::map<short, WaveData*>* >(_data);
    if (!mwdata) throw BadData("InputFileBase::WData", electrode);
    WaveData* wave_data = (*mwdata)[electrode];
    return wave_data;
}
std::vector<short> InputFileBase::VElectrodes() const
{
    std::vector<short> electrodes = ut::ToVector(_electrodes);
    return electrodes;
}
