#include "wfmfilein.h"

WfmFileIn::WfmFileIn(const std::string& full_path)
    : InputFileBase(full_path, true)
{
}

int WfmFileIn::Load()
{
    FILE* fp = File();

    if (!fp) throw BadFileName("WfmFileIn::Load", Name());

    FileBase::WfmHeader header;
    fread(&header, sizeof(FileBase::WfmHeader), 1, fp);

    int num_records = header.num_records,
        num_samples = header.num_samples;
    wv_matrix* waves = wv_matrix_alloc(num_records, num_samples);
    wv_matrix_fread(fp, waves);
    SetData(waves);

    return num_records;
}
