#ifndef ACPARAMSOUT_H
#define ACPARAMSOUT_H

#include "outputfilebase.h"
#include "../../memrep/parameters/cluster/autoclasspars.h"

//For AutoClass
class ACParamsOut : public OutputFileBase
{
    public:
        enum PARAM_TYPE
        {
            SEARCH,
            RESULTS
        };

        ACParamsOut(const std::string& file_name, PARAM_TYPE param_type,
                    ParamsCPtr autoclass_pars, int num_all_samples);

        virtual void Save() const override;

    private:
        PARAM_TYPE _paramType;
        ParamsCPtr _autoclassPars;
        int _numAllSamples; // # records x # samples per record
};

#endif // ACSPARAMSOUT_H
