#include "clufileout.h"

CluFileOut::CluFileOut(const QString& file_name, const Classification* cls)
    : OutputFileBase(file_name, false, NULL, QBitArray(cls->VCluster()->size)),
      _maxClass(cls->MaxClass()), _vCluster(cls->VCluster())
{
}
CluFileOut::CluFileOut(const QString& file_name, int max_class, const gsl_vector_int* vcluster)
    : OutputFileBase(file_name, false, NULL, QBitArray(vcluster->size)), _maxClass(max_class), _vCluster(vcluster)
{
}

void CluFileOut::Save() const
{
    FILE* clu = File();
    if (clu)
    {
        fprintf(clu, "%d\n", _maxClass);
        int code = gsl_vector_int_fprintf(clu, _vCluster, "%d");
        if (code) Log("ERROR: Cluster analysis not written correctly to temporary file.");
    }
    else
        Log("WARNING: Invalid file name, " + Name() + ", no records saved.");
}
