#include "db2fileout.h"

Db2FileOut::Db2FileOut(const std::string& filename, MatCPtr waves, int samples_begin, int samples_end)
    : OutputFileBase(filename, false, NULL, boost::dynamic_bitset<>(waves->size1)),
      _waves(waves), _samplesBegin(samples_begin), _samplesEnd(samples_end)
{
}

void Db2FileOut::Save() const
{
    FILE* fp = File();
    if (fp)
    {
        int num_records = _waves->size1,
                samples_range = _samplesEnd-_samplesBegin;
        char title[9] = ".db2-bin";
        uint bytes_per_record = samples_range * sizeof(float);

        fwrite(title, 1, 8, fp);
        fwrite(&bytes_per_record, sizeof(uint), 1, fp);
        for (int i=0; i<num_records; ++i)
            for (int j=_samplesBegin; j<_samplesEnd; ++j)
            {
                float val = (float)wv_matrix_get(_waves.get(), i, j);
                fwrite(&val, sizeof(float), 1, fp);
            }
    }
    else
        Log("ERROR: Could not write temporary file, check path: " + Path());
}
