#include "modelfileout.h"

ModelFileOut::ModelFileOut(const std::string& file_name, bool is_user, int num_samples)
    : OutputFileBase(file_name, false, NULL, boost::dynamic_bitset<>()), _isUser(is_user), _numSamples(num_samples)
{
}

void ModelFileOut::Save() const
{
    FILE* fp = File();
    if (fp)
    {
        fprintf(fp, "model_index 0 1\n");
        if (_isUser)
            fprintf(fp, "single_normal_cn");
        else
            fprintf(fp, "multi_normal_cn");
        for (int j=0; j<_numSamples; ++j)
            fprintf(fp, " %d", j);
        fprintf(fp, "\n");
    }
    else
        Log("WARNING: Invalid file name, " + Name() + ", no records loaded.");
}
