#include "simpleascii.h"

SimpleAscii::SimpleAscii(const std::string& name, const WaveData* data, const boost::dynamic_bitset<>& accepted)
    : OutputFileBase(name, false, data, accepted)
{
    const boost::dynamic_bitset<>& is_scrubbed = Data()->Scrubbed(); //This has the size of the *original* number of
        //records.
    _allIsAccepted = boost::dynamic_bitset<>( is_scrubbed.size() );
    int num_records = Data()->NumRecords();
    _numAllRecords = num_records + is_scrubbed.count();
    int ct=0; //This ct is for *non-scrubbed* records, which is what IsAccepted indexes.
    for (int i=0; i<_numAllRecords; ++i)
    {
        if (is_scrubbed.test(i)) continue;
        _allIsAccepted.set( i, IsAccepted(ct) );
        ++ct;
    }
}

void SimpleAscii::Save() const
{
    FILE* file = File();
    fprintf(file, "%d\n", _numAllRecords);
    for (int i=0; i<_numAllRecords; ++i)
        fprintf(file, "%d\n", (int)_allIsAccepted.test(i));
}
