#include "wfmfile.h"

WfmFile::WfmFile(const QString& filename, const gsl_matrix* waves, const FileBase::WfmHeader& header)
    : OutputFileBase(filename, true, NULL, QBitArray(waves->size1)),
      _header(header), _waves(waves)
{
}

void WfmFile::Save()
{
    int num_records = _header.num_records,
            num_samples = _header.num_samples;

    FILE* temp = File();
    fwrite(&_header, sizeof(FileBase::WfmHeader), 1, temp);

    //Now write all the data points
    for (int i=0; i<num_records; ++i)
        for (int j=0; j<num_samples; ++j)
        {
            float f = (float)gsl_matrix_get(_waves,i,j);
            fwrite(&f, sizeof(float), 1, temp);
        }
        //Ideally want to write without typecasting and just use gsl_matrix_fwrite, but will settle
        //for this for now
    Close();
}
