#ifndef WFMFILEAPPEND_H
#define WFMFILEAPPEND_H

#include "filebase.h"

//In the initial read, we don't store waveforms in memory--too costly, impossible for large files.
//Instead we write directly to electrode-specific files
class WfmFileAppend : public FileBase
{
    public:
        const static int BUFFER_SIZE;
        WfmFileAppend(const std::string& name);
        virtual ~WfmFileAppend() override;

        void Append(const wv_matrix* mat, int num_to_write = -1) const;

    private:
        char* _buffer; //Critical!
};

#endif // WFMFILEAPPEND_H
