#ifndef STL_HEADERS_H
#define STL_HEADERS_H

#include <qglobal.h>

#include <cmath>
#include <ctime>
#include <stdio.h>
#include <cstddef>
#include <string>
#include <algorithm>
#include <limits>
#ifndef Q_OS_WIN
#include <unistd.h>
#endif
#include <iostream>
#include <fstream>
#include <sstream>
#include <exception>
#include <stdexcept> //Don't know how this is different from <exception>
#include <memory>
#include <thread>
#include <mutex>
#ifndef Q_OS_WIN
#include <atomic>
#endif
#include <chrono>
#include <functional>

#include <vector>
#include <list>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <tuple>

#include <utility>  //i.a. pair

#ifdef Q_OS_WIN
#define bzero(p, size)     (void)memset((p), 0, (size))
    //VC++ doesn't have this
#endif

typedef std::list<std::string> StringList;
typedef std::vector<std::string> StringVec;
#ifndef Q_OS_WIN
template<typename T, typename U> using VecPairs = std::vector< std::pair<T, U> >;
#endif
typedef std::lock_guard<std::mutex> MutexLocker;

#endif // STL_HEADERS_H
