#ifndef UT_DEF_H
#define UT_DEF_H

#include "utils.h"

template<typename T>
T ut::Split(const std::string& str, const std::string& sep)
{
    T string_list;
    std::string str2(str);
    while (!str2.empty())
    {
        std::string::size_type pos = str2.find_first_of(sep);
        if (pos==std::string::npos)
        {
            string_list.push_back(str2);
            return string_list;
        }
        std::string token = str2.substr(0, pos);
        string_list.push_back(token);
        str2.erase(0, (int)(pos)+1);
    }
    return string_list;
}

template<typename T, typename U>
std::vector<T> ut::Keys(const std::map<T, U>& mp)
{
    std::vector<T> keys;
    for (const auto& iter : mp) keys.push_back(iter.first);
    return keys;
}

template<typename T>
int ut::IndexOf(const std::vector<T>& vec, T val)
{
    auto it = std::find(vec.begin(), vec.end(), val);
    return (it==vec.end()) ? -1 : it - vec.begin();
}

template<typename T>
T ut::TakeFirst(std::list<T>& ls)
{
    T front = ls.front();
    ls.pop_front();
    return front;
}

template<typename T>
std::list<T> ut::ToList(const std::set<T>& st)
{
    std::list<T> ls;
    for (const auto& item : st)
        ls.push_back(item);
    return ls;
}

template<typename T>
QVector<T> ut::ToQVector(const std::vector<T>& vec)
{
    QVector<T> qvec;
    for (const auto& item : vec)
        qvec.push_back(item);
    return qvec;
}
template<typename T>
std::list<T> ut::ToList(const QList<T>& qlist)
{
    std::list<T> ls;
    for (auto item : qlist)
        ls.push_back(item);
    return ls;
}

template<typename T>
std::vector<T> ut::ToVector(const std::set<T>& st)
{
    std::vector<T> vec;
    for (const auto& item : st)
        vec.push_back(item);
    return vec;
}

template<typename T>
std::vector<T> ut::ToVector(const QVector<T>& qvec)
{
    std::vector<T> vec;
    for (const auto& item : qvec)
        vec.push_back(item);
    return vec;
}

#endif // UT_DEF_H
