#ifndef PARAMGUI_H
#define PARAMGUI_H

#include "../../memrep/parameters/paramsbase.h"
#include "../../file/output/profileout.h"
#include "../gui.h"

namespace Ui {
    class ParamGui;
}

class ParamGui : public QWidget
{
    Q_OBJECT

    public:
        explicit ParamGui(QWidget *parent);
        ~ParamGui();

        void SetParameters(std::shared_ptr<ParamsBase> pars);

        const std::shared_ptr<ParamsBase> Params() const { return _pars; }

    signals:
        void Cluster();

    public slots:
        void on_btnDefaults_clicked() { gui::Slot(this, &ParamGui::OnBtnDefaultsClicked); }
        void on_btnSaveToProfile_clicked() { gui::Slot(this, &ParamGui::OnBtnSaveToProfileClicked); }
        void on_tblPars_itemChanged(QTableWidgetItem* item);

    protected:
        void paintEvent(QPaintEvent*);

    private:
        void OnBtnDefaultsClicked(bool is_prog = true);
        void OnBtnSaveToProfileClicked(bool is_prog = true);

        Ui::ParamGui *ui;
        std::shared_ptr<ParamsBase> _pars;
        bool _isParamsChanged;

        std::string _file; //Read/save parameter files...
};

#endif // PARAMGUI_H
