#ifndef CLUSWAVEWIDGET_H
#define CLUSWAVEWIDGET_H

#include "wavewidget.h"

class ClusWaveWidget : public WaveWidget
{
    public:
        ClusWaveWidget(QWidget* parent);

        virtual void SetSamplesBegin(int samples_begin) override { _samplesBegin = samples_begin; }
        virtual void SetSamplesEnd(int samples_end) override { _samplesEnd = samples_end; }

        virtual int SamplesBegin() const override { return _samplesBegin; }
        virtual int SamplesEnd() const override { return _samplesEnd; }

    protected:
        virtual void mousePressEvent (QMouseEvent* event) override;
        virtual void mouseMoveEvent(QMouseEvent *) override; //NB by default these occur only when the mouse button is pressed.
        virtual void mouseReleaseEvent (QMouseEvent*) override;
        virtual void wheelEvent(QWheelEvent* event) override;

    private:
        int _mouseYPos, //Which sample is selected by the sliding cursor
            _samplesBegin, _samplesEnd; //0 to number of samples in wv::RAW--need to do it with members
            //and accessor functions for homogeneity of interface
};

#endif // CLUSWAVEWIDGET_H
