#include "circle.h"

Circle::Circle(ID id) : DrawLineBase(id)
{
}
Circle::Circle(const Circle& circle) : DrawLineBase(circle)
{
}
Circle::Circle() : DrawLineBase()
{
}
Circle& Circle::operator=(const Circle& circle)
{
    if (this != &circle)
        DrawLineBase::operator=(circle);
    return *this;
}
Circle::~Circle()
{
}

bool Circle::Contains(wv::float_t x, wv::float_t y) const
{
    //See docs/pnpoly_license.txt for the author/license of this algorithm
    int i, j;
    bool b = false;
    for (i = 0, j = _length-1; i < _length; j = i++)
    {
        if ( ((_points[i].y()>y) != (_points[j].y()>y))
             && (x < (_points[j].x()-_points[i].x()) * (y-_points[i].y()) / (_points[j].y()-_points[i].y())
                            + _points[i].x()) )
            b = !b;
    }
    return b;
        //Can't simply use QPolygon::containsPoint because you can't construct a QPolygon from
        //a C array without doing a full copy.
}
