#ifndef CIRCLE_H
#define CIRCLE_H

#include "drawlinebase.h"

class Circle : public DrawLineBase
{
    public:
        Circle(ID id);
        Circle();
        Circle(const Circle& circle);
        Circle& operator=(const Circle& circle);
        virtual DrawLineBase* Clone() override { return new Circle(*this); }
        virtual ~Circle() override;

        bool Contains(wv::float_t x, wv::float_t y) const; //value coordinates
};


struct CircleSpec : public DrawLineBaseSpec
{
    CircleSpec(wv::TRANSFORM tr_x, wv::TRANSFORM tr_y, int s_x, int s_y, Circle* circle)
        : DrawLineBaseSpec(tr_x, tr_y, s_x, s_y, circle)
    {
    }
    CircleSpec() {}
    virtual ~CircleSpec() override {}

    virtual Circle* GetDrawLine() override
    {
        return static_cast<Circle*>( DrawLineBaseSpec::GetDrawLine() );
    }
    virtual const Circle* GetDrawLine() const override
    {
        return static_cast<const Circle*>( DrawLineBaseSpec::GetDrawLine() );
    }
};
typedef CircleSpec CSpec;
    //NB, NO tid, user transforms not allowed with Manual sorting.

#endif // CIRCLE_H
