#ifndef HISTWGTTO_H
#define HISTWGTTO_H

#include "../../globals/globals.h"
#include "../../gui/widgets/histwidget.h"
#include "../../analysis/threads/worker/workerto.h"

class HistWgtTO : public WorkerTO
{
    Q_OBJECT
    public:
        explicit HistWgtTO(int thd_num, uchar* pixels, const HistWidget* hist_widget,
                        int jstart, int jend, double max_val);

    public slots:
        void Start();

    private:
        uchar* _pixels;
        const HistWidget* _histWidget;
        const DrawLineBase::ScaleSpec& _scaleSpec;
        const gsl_histogram2d* _histAccept, * _histUnaccept;
        int _histWidth,
            _jStart, _jEnd, //Defines the range of columns that this thread is responsible for
            _maxVal;
};

#endif // HISTWGTTO_H
