#include "autoclasspars.h"

AutoClassPars::AutoClassPars() : ClusterParamsBase("AutoClass")
{
    Insert("samples_begin", "-1", true);
    Insert("samples_end", "-1", true);
    Insert("Classification p-value", "0.5"); //The threshold probability required to accept
        //the classification (as opposed to putting it in wv::NULL_CLUSTER)
    Insert("WS-PARAMS END", "", true); //A dummy parameter to say when the WS parameters end
        //parameters are complete

    //These are for the search file
    Insert("rel_error", "0.0001"); //This is *multiplied* by the *range*
    Insert("start_j_list", "2, 3, 4, 5");
        // AutoClass original: 2, 3, 5, 7, 10, 15, 25");
    Insert("n_classes_fn_type", "\"random_ln_normal\"");
    Insert("fixed_j", "0");
    Insert("min_report_period", "1000000");
    Insert("max_duration", "100"); //This is now MICROSECONDS PER SAMPLE,
        //converted to total duration in ACParamsOut
    Insert("max_n_tries", "0");
    Insert("n_save", "2");
    Insert("log_file_p", "true");
    Insert("min_save_period", "1800");
    Insert("max_n_store", "10");
    Insert("try_fn_type", "\"converge_search_3\"");
    Insert("initial_cycles_p", "true");
    Insert("save_compact_p", "true");
    Insert("read_compact_p", "true");
    Insert("halt_range", "0.5");
    Insert("halt_factor", "0.0001");
    Insert("rel_delta_range", "0.0025");
    Insert("cs4_delta_range", "0.0025");
    Insert("n_average", "3");
    Insert("sigma_beta_n_values", "6");
    Insert("max_cycles", "200");
    Insert("converge_print_p", "false");
    Insert("checkpoint_p", "false");
    Insert("min_checkpoint_period", "10800");
    Insert("reconverge_type", "\"\"");
    Insert("screen_output_p", "true");
    Insert("interactive_p", "true");
    Insert("break_on_warnings_p-s", "false", true);
    Insert("free_storage_p-s", "true", true);
    Insert("S-PARAMS END", "", true); //A dummy parameter to say when the search
        //parameters are complete

    //The following are for the results file
    Insert("n_clsfs", "1");
    Insert("clsf_n_list", "1");
    Insert("report_type", "\"all\"");
    Insert("report_mode", "\"data\"", true); //Original: "text"
    Insert("comment_data_headers_p", "false");
    Insert("num_atts_to_list", "5");
    Insert("xref_class_report_att_list", "1 2 3 4 5");
    Insert("order_attributes_by_influence_p", "true");
    Insert("break_on_warnings_p-r", "false", true);
    Insert("free_storage_p-r", "true", true);
    Insert("max_num_xref_class_probs", "5");
    Insert("sigma_contours_att_list", "");

    //From search-control.c:
    /* aju 980612: Added conditionality on interactive_p */
    /* 01jul98 wmt: removed conditionality -- important that user is warned */
    /* 22apr00 wmt: bring back conditionality, to prevent batch runs from
       going into a loop */
//    if ((force_new_search_p == TRUE) && ( results_file_found == TRUE)) {
//      if (interactive_p == TRUE) {
//        fprintf( stderr, "\nWARNING: force_new_search_p is true and continuing will"
//                 " discard the \n         search trials in:\n         %s%s\n",
//                 G_absolute_pathname, results_file_ptr);
  /*      sprintf( str, "Do you want to continue {y/n} ");
        if (! y_or_n_p( str))
          exit(1);
  */
    //    }
    //I took out the prompt so that I wouldn't have to deal with this in the program.
    //If there's a problem with this in batch mode check here.

}
