#ifndef CLUSTERPARAMSBASE_H
#define CLUSTERPARAMSBASE_H

#include "../paramsbase.h"

//Basically there is just one thing this class does that ParamsBase doesn't, namely
//allow Range Parameters to be set.  This is very convenient for clustering algormithms,
//for which these parameters are important but generally tacit.

class ClusterParamsBase;
typedef std::shared_ptr<ClusterParamsBase> ClusterParamsPtr;

class ClusterParamsBase : public ParamsBase
{
    public:
        ClusterParamsBase(const std::string& name);
        virtual ~ClusterParamsBase() override {}
        static ClusterParamsPtr Create(wv::CLUSTER_METHOD method);

        virtual void SetSampleRangePars(); //The intent is that this is called only just
            //just before clustering--loading the selected samples from the spec into
            //the parameter list.
};

#endif // CLUSTERPARAMSBASE_H
