#include "kkparameters.h"
#include "../../../memrep/clustermediator.h"

KKParameters::KKParameters() : ClusterParamsBase("KlustaKwik")
{
    Insert("MinClusters", "1");
        //Original: 20
    Insert("MaxClusters", "10");
        //Original: 20
    Insert("MaxPossibleClusters", "20");
        //Original; 100
    Insert("nStarts", "20");
    Insert("RandomSeed", "1");
    Insert("Debug", "0");
    Insert("Verbose", "0");
    Insert("UseFeatures", "", true);
        //Original: 11111111111100001
    Insert("DistDump", "0");
    Insert("DistThresh", "6.90775"); //log(1000)
    Insert("FullStepEvery", "20");
    Insert("ChangedThresh", "0.05");
    Insert("Log", "1");
    Insert("Screen", "1");
    Insert("MaxIter", "500");
    Insert("StartCluFile", "");
    Insert("SplitEvery", "40");
    Insert("PenaltyMix", "1.0");
    Insert("Subset", "1");
}

void KKParameters::SetSampleRangePars()
{
    CluSpecPtr clu_spec = ClusterMediator::Instance().GetCluSpecPtr(wv::DEFAULT_CID);
    int begin = clu_spec->SelectedSamplesBegin(),
            end = clu_spec->SelectedSamplesEnd(),
            num_samples = clu_spec->NumSamples();
    std::string use_features;
    for (int i=0; i<num_samples; ++i)
        use_features.push_back( (i>=begin && i<end) ? '1' : '0' );
    SetPar("UseFeatures", use_features);
}
