#ifndef PROFILE_H
#define PROFILE_H

#include "../../globals/globals.h"
#include "../../globals/log.h"

typedef std::pair<std::string, std::string> Param;
typedef std::vector<Param> ParamVec;
class Profile
{
    public:
        static const std::string BAD_PARAMETER;
        Profile();

        void AddParList(const std::string& list_name, const ParamVec& par_list);
        void AddPar(const std::string& list_name, const Param& par);
        void Write(FILE* fp, const std::string& list_name) const;

        void SetPar(const std::string& list_name, const std::string& key, const std::string& value);

        bool IsParList(const std::string& name) const;
        ParamVec ParList(const std::string& list_name) const { return _paramLists.at(list_name); }
        StringVec ParLists() const { return ut::Keys(_paramLists); }
        std::string Par(const std::string& list_name, const std::string& key) const;

    private:
        std::map<std::string, ParamVec> _paramLists;
};

extern Profile session_profile;

#endif // PROFILE_H
