#include "sessionpars.h"

SessionPars::SessionPars() : ParamsBase("Session")
{
    Insert("Data Directory", "");
    Insert("WS Data Directory", "");
    Insert("Align waves", "none"); //peak, trough, none
    Insert("Scrub threshold (SDs)", "4.00");
    Insert("Num Spline Breakpoints", "8");
    Insert("Num PCA components", "8");
    Insert("Num Batch Threads", "1");
    Insert("Wavelet size (or \"haar\")", "haar");
        //Daubechies: 4,6,8,10,12,14,16,18,20
        //bspline: 103, 105,202,204,206,208,301,303,305,307,309
    Insert("Is wavelet centered", "yes");
    Insert("Make PCA", "yes");
#ifdef USE_GSL
    Insert("Make Spline", "no");
    Insert("Make Fourier", "no");
#endif
    Insert("Make Wavelets", "yes");
    Insert("Make Raw-D", "yes");
    Insert("Make PCA-D", "yes");
#ifdef USE_GSL
    Insert("Make Spline-D", "no");
    Insert("Make Fourier-D", "no");
#endif
    Insert("Make Wavelets-D", "yes");
#ifdef HAS_CUDA
    Insert("Enable CUDA", "no");
#endif
//    Insert("Max Threads per Process", "auto");
}

// ### Make all parameters const strings defined in wv!
